<?xml version="1.0"?>

<!DOCTYPE xml [
  <!ENTITY ENABLE_ZS "true">
  <!ENTITY OUTPUT_PATH "/gemdata/runs/minidaq/">
  <!ENTITY AUTOMASKER_MASKING_PERIOD "1000">
  <!ENTITY AUTOMASKER_SEU_RECOVERY_PERIOD "10000">
  <!ENTITY POWER_CYCLE_TIMEOUT "10">
  <!ENTITY POWER_ON_TIMEOUT "10">
]>

<xc:Partition xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
              xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/"
              xmlns:xc="http://xdaq.web.cern.ch/xdaq/xsd/2004/XMLConfiguration-30">
  <xc:Context url="http://gem-daq01.cms:20400">

    <xc:Module>/usr/lib64/libgemsupervisor.so</xc:Module> <!-- ID prefix: 1 -->
    <xc:Module>/usr/lib64/libgemcalibration.so</xc:Module> <!-- ID prefix: 2 -->
    <xc:Module>/usr/lib64/libgemmanagers.so</xc:Module> <!-- ID prefix: 4 -->
    <xc:Module>/usr/lib64/libgemreadout.so</xc:Module> <!-- ID prefix: 5 -->

    <!-- ID = 1000, instance = 000 -->
    <xc:Application class="gem::supervisor::GEMSupervisor" id="1000" instance="000" service="supervisor" network="local">
      <properties xmlns="urn:xdaq-application:gem::supervisor::GEMSupervisor" xsi:type="soapenc:Struct">
        <UseFedKitReadout xsi:type="xsd:boolean">false</UseFedKitReadout>

        <TCDSConfig xsi:type="soapenc:Struct">
          <HandleTCDS xsi:type="xsd:boolean">true</HandleTCDS>
          <UsePrimaryTCDS xsi:type="xsd:boolean">true</UsePrimaryTCDS>
          <PISkipPLLReset xsi:type="xsd:boolean">false</PISkipPLLReset>
          <FEDEnableMask xsi:type="xsd:string">%</FEDEnableMask>
          <CPMHardwareConfig xsi:type="xsd:string"></CPMHardwareConfig>
          <LPMHardwareConfig xsi:type="xsd:string"></LPMHardwareConfig>
          <ICIHardwareConfig xsi:type="xsd:string">/etc/cmsgemos/tcds/hw-cfg-gem-ici-with-ipm2.txt</ICIHardwareConfig>
          <PIHardwareConfig xsi:type="xsd:string">/etc/cmsgemos/tcds/hw-cfg-gem-pi.txt</PIHardwareConfig>
        </TCDSConfig>

        <ReportStateToRCMS xsi:type="xsd:boolean">true</ReportStateToRCMS>
        <rcmsStateListener xsi:type="soapenc:Struct">
          <classname xsi:type="xsd:string">RCMSStateListener</classname>
          <instance  xsi:type="xsd:unsignedInt">0</instance>
        </rcmsStateListener>

        <outputPath xsi:type="xsd:string">&OUTPUT_PATH;</outputPath>
      </properties>
    </xc:Application>

    <!-- ID = 2000, instance = 000 -->
    <xc:Application class="gem::calibration::Calibration" id="2000" instance="000" service="calibration" network="local">
      <properties xmlns="urn:xdaq-application:gem::calibration::Calibration" xsi:type="soapenc:Struct">
        <!-- Hardware description -->
        <nFED xsi:type="xsd:integer">1</nFED>
      </properties>
    </xc:Application>

    <!-- ID = 4xxxxyy, instance = xxxxyy, xxxx = FED, yy = slot -->
    <!-- ID = 4xxxx13, instance = xxxx13, xxxx = FED -->

    <!-- FED 1469 managers -->

    <xc:Application class="gem::managers::AMCManager" id="4146901" instance="146901" network="local">
      <properties xmlns="urn:xdaq-application:gem::managers::AMCManager" xsi:type="soapenc:Struct">
        <!-- Hardware description -->
        <fedID xsi:type="xsd:unsignedInt">1469</fedID>
        <slot xsi:type="xsd:unsignedInt">1</slot>

        <!-- Configuration -->
        <automaskerMaskingPeriod xsi:type="xsd:unsignedInt">&AUTOMASKER_MASKING_PERIOD;</automaskerMaskingPeriod>
        <automaskerSEURecoveryPeriod xsi:type="xsd:unsignedInt">&AUTOMASKER_SEU_RECOVERY_PERIOD;</automaskerSEURecoveryPeriod>
        <enableZS xsi:type="xsd:boolean">&ENABLE_ZS;</enableZS>
        <powerCycleTimeout xsi:type="xsd:unsignedInt">&POWER_CYCLE_TIMEOUT;</powerCycleTimeout>
        <powerOnTimeout xsi:type="xsd:unsignedInt">&POWER_ON_TIMEOUT;</powerOnTimeout>

        <!-- Output of non-tracking data calibration scans -->
        <outputPath xsi:type="xsd:string">&OUTPUT_PATH;</outputPath>
      </properties>
    </xc:Application>

    <xc:Application class="gem::managers::AMCManager" id="4146903" instance="146903" network="local">
      <properties xmlns="urn:xdaq-application:gem::managers::AMCManager" xsi:type="soapenc:Struct">
        <!-- Hardware description -->
        <fedID xsi:type="xsd:unsignedInt">1469</fedID>
        <slot xsi:type="xsd:unsignedInt">3</slot>

        <!-- Configuration -->
        <automaskerMaskingPeriod xsi:type="xsd:unsignedInt">&AUTOMASKER_MASKING_PERIOD;</automaskerMaskingPeriod>
        <automaskerSEURecoveryPeriod xsi:type="xsd:unsignedInt">&AUTOMASKER_SEU_RECOVERY_PERIOD;</automaskerSEURecoveryPeriod>
        <enableZS xsi:type="xsd:boolean">&ENABLE_ZS;</enableZS>
        <powerCycleTimeout xsi:type="xsd:unsignedInt">&POWER_CYCLE_TIMEOUT;</powerCycleTimeout>
        <powerOnTimeout xsi:type="xsd:unsignedInt">&POWER_ON_TIMEOUT;</powerOnTimeout>

        <!-- Output of non-tracking data calibration scans -->
        <outputPath xsi:type="xsd:string">&OUTPUT_PATH;</outputPath>
      </properties>
    </xc:Application>

    <xc:Application class="gem::managers::AMC13Manager" id="4146913" instance="146913" network="local">
      <properties xmlns="urn:xdaq-application:gem::managers::AMC13Manager" xsi:type="soapenc:Struct">
        <!-- Hardware description -->
        <fedID xsi:type="xsd:unsignedInt">1469</fedID>

        <amc13ConfigParams xsi:type="soapenc:Struct">
          <AMCInputEnableList xsi:type="xsd:string">1</AMCInputEnableList>
          <AMCIgnoreTTSList xsi:type="xsd:string">2-12</AMCIgnoreTTSList>

          <EnableDAQLink xsi:type="xsd:boolean">true</EnableDAQLink>
          <EnableFakeData xsi:type="xsd:boolean">false</EnableFakeData>
          <MonitorBackPressure xsi:type="xsd:boolean">false</MonitorBackPressure>

          <!--Scan Routines Config -->
          <!-- LOCAL TRIGGERS = enableLocalL1A = true, LEMO false, EnableLocalTTC true -->
          <!-- LEMO TRIGGERS  = enableLocalL1A = true, LEMO true, EnableLocalTTC true -->
          <!-- EXTERNAL TRIGGERS (TTC) = enableLocalL1A = false, LEMO false, EnableLocalTTC false -->

          <EnableLocalTTC xsi:type="xsd:boolean">false</EnableLocalTTC>
          <LocalTriggerConfig xsi:type="soapenc:Struct">
            <EnableLocalL1A xsi:type="xsd:boolean">false</EnableLocalL1A>
            <EnableLEMO xsi:type="xsd:boolean">false</EnableLEMO>

            <!--  L1Amode: Select the mode of the local trigger generator
                  0 - per N orbit (N specified by period), always at BX 500
                  1 - per N BX (N specified by period)
                  2 - random (rate specified by period, in 2Hz units)
                  InternalPeriodicPeriod: frequency of trigger  -->
            <InternalPeriodicPeriod xsi:type="xsd:unsignedInt">100</InternalPeriodicPeriod>
            <L1Aburst xsi:type="xsd:unsignedInt">1</L1Aburst>
            <L1Amode xsi:type="xsd:integer">0</L1Amode>
            <L1Arules xsi:type="xsd:integer">0</L1Arules>
            <sendL1ATriburst xsi:type="xsd:boolean">false</sendL1ATriburst>
            <startL1ATricont xsi:type="xsd:boolean">false</startL1ATricont>
          </LocalTriggerConfig>

          <AMC13TTCConfig xsi:type="soapenc:Struct">
            <RESYNC_CMD xsi:type="xsd:unsignedInt">0x04</RESYNC_CMD>
            <RESYNC_MASK xsi:type="xsd:unsignedInt">0x01</RESYNC_MASK>
            <OC0_CMD xsi:type="xsd:unsignedInt">0x08</OC0_CMD>
            <OC0_MASK xsi:type="xsd:unsignedInt">0x01</OC0_MASK>
          </AMC13TTCConfig>

          <!-- <BGOConfig xsi:type="soapenc:Array" soapenc:arrayType="xsd:ur-type[4]"> -->
          <!--   <BGOInfo xsi:type="soapenc:Struct" soapenc:position="0"> -->
          <!--     <BGOChannel xsi:type="xsd:integer">0</BGOChannel> -->
          <!--     <BGOcmd xsi:type="xsd:unsignedInt">0x14</BGOcmd> -->
          <!--     <BGObx xsi:type="xsd:unsignedInt">450</BGObx> -->
          <!--     <BGOprescale xsi:type="xsd:unsignedInt">0x1</BGOprescale> -->
          <!--     <BGOrepeat xsi:type="xsd:boolean">true</BGOrepeat> -->
          <!--   </BGOInfo> -->
          <!-- </BGOConfig> -->

          <PrescaleFactor xsi:type="xsd:integer">1</PrescaleFactor>
          <BCOffset xsi:type="xsd:integer">1</BCOffset>

          <SFPMask xsi:type="xsd:unsignedInt">1</SFPMask>
          <SlotMask xsi:type="xsd:unsignedInt">1</SlotMask>
          <SkipPLLReset xsi:type="xsd:boolean">false</SkipPLLReset>
        </amc13ConfigParams>
      </properties>
    </xc:Application>

  </xc:Context>

  <xc:Context url="http://tcds-control-csc-pri.cms:2104">
    <!-- GEMPILOT TCDS applications -->
    <xc:Application class="tcds::ici::ICIController" id="305" instance="0" network="local" />
    <xc:Application class="tcds::pi::PIController" id="505" instance="0" network="local" />
  </xc:Context>

  <xc:Context url="http://cmsrc-gem.cms:20000/rcms">
    <xc:Application class="RCMSStateListener" id="12" instance="0" network="local" path="/services/replycommandreceiver" />
    <xc:Application class="RCMSStateListener" id="13" instance="1" network="local" path="/rcms/services/errorreceiver"/>
  </xc:Context>

</xc:Partition>
